#include<iostream>
using namespace std;
int main()
{
    int n,x,y,g=-1,ots=0,br=0;
    cin>>n;
    int mas[2*n-1];
    int allnum[100000];
    for (int i=0; i<n; i++)
    {
        cin>>x>>y;
        mas[i]=x;
        mas[i+1]=y;
    }
    for (int i=0; i<2*n; i+=2)
    {
        for (int m=mas[i]; m<mas[i+1]; m++)
        {
            g++;
            allnum[g]=m;
        }
    }
    for (int i=0; i<g; i++)
    {
        if (allnum[i]>ots)
        {
            ots=allnum[i];
            br=0;
        }
        if (allnum[i]==ots)
        {
            br++;
        }
    }
    cout<<ots<<endl<<br<<endl;
    return 0;
}
